/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package forms;

import dao.AgendamentoDao;
import dao.ClienteDao;
import dao.ServicoDao;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JOptionPane;
import javax.swing.table.DefaultTableModel;
import model.Agendamento;
import model.Cliente;
import model.Servico;

/**
 *
 * @author alcebiades
 */
public class FormAgendamento extends javax.swing.JFrame {
    
    Agendamento agendamento;

    DefaultTableModel modelo;

    /**
     * Creates new form FormAgendamento
     */
    public FormAgendamento() {
        initComponents();
        modelo = (DefaultTableModel) jtAgendamento.getModel();
        setServicoGUI();
        agendamento = new Agendamento();
        agendamento.setCliente(new Cliente());
        cbHorario.setEnabled(false);
    }

    public FormAgendamento(Cliente cliente) {
        initComponents();
        modelo = (DefaultTableModel) jtAgendamento.getModel();
        if (cliente == null)
            return;
        
        agendamento = new Agendamento();
        agendamento.setCliente(cliente);
        
        lbNome.setText(cliente.getNome());
        lbSexo.setText(cliente.getSexo());
        lbTelefone.setText(cliente.getTelefone());
        ftfCpf.setText(cliente.getCpf());
        setServicoGUI();
        cbHorario.setEnabled(false);
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jpCliente = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        btBuscar = new javax.swing.JButton();
        jLabel2 = new javax.swing.JLabel();
        lbNome = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        lbSexo = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        lbTelefone = new javax.swing.JLabel();
        ftfCpf = new javax.swing.JFormattedTextField();
        jPanel2 = new javax.swing.JPanel();
        jLabel8 = new javax.swing.JLabel();
        dcData = new com.toedter.calendar.JDateChooser();
        jLabel9 = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jtAgendamento = new javax.swing.JTable();
        jLabel10 = new javax.swing.JLabel();
        btAdicionar = new javax.swing.JButton();
        cbHorario = new javax.swing.JComboBox<>();
        btRemover = new javax.swing.JButton();
        cbServico = new javax.swing.JComboBox<>();
        btExibir = new javax.swing.JButton();
        jLabel3 = new javax.swing.JLabel();
        btAgendar = new javax.swing.JButton();
        jLabel11 = new javax.swing.JLabel();
        lbValorParcial = new javax.swing.JLabel();
        btCancelar = new javax.swing.JButton();
        btLimparCampos = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Agendar Atendimento");
        setResizable(false);

        jpCliente.setBorder(javax.swing.BorderFactory.createTitledBorder(javax.swing.BorderFactory.createEtchedBorder(), "Cliente"));

        jLabel1.setText("CPF:");

        btBuscar.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagens/system-search-3.png"))); // NOI18N
        btBuscar.setText("Buscar");
        btBuscar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btBuscarActionPerformed(evt);
            }
        });

        jLabel2.setText("Nome:");

        lbNome.setText("---");

        jLabel4.setText("Sexo:");

        lbSexo.setText("---");

        jLabel6.setText("Telefone:");

        lbTelefone.setText("---");

        try {
            ftfCpf.setFormatterFactory(new javax.swing.text.DefaultFormatterFactory(new javax.swing.text.MaskFormatter("###.###.###-##")));
        } catch (java.text.ParseException ex) {
            ex.printStackTrace();
        }

        javax.swing.GroupLayout jpClienteLayout = new javax.swing.GroupLayout(jpCliente);
        jpCliente.setLayout(jpClienteLayout);
        jpClienteLayout.setHorizontalGroup(
            jpClienteLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jpClienteLayout.createSequentialGroup()
                .addGap(22, 22, 22)
                .addGroup(jpClienteLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jpClienteLayout.createSequentialGroup()
                        .addComponent(jLabel2)
                        .addGap(18, 18, 18)
                        .addComponent(lbNome)
                        .addGap(239, 239, 239)
                        .addComponent(jLabel4))
                    .addGroup(jpClienteLayout.createSequentialGroup()
                        .addComponent(jLabel1)
                        .addGap(18, 18, 18)
                        .addComponent(ftfCpf, javax.swing.GroupLayout.PREFERRED_SIZE, 180, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addComponent(btBuscar)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(lbSexo)
                .addGap(112, 112, 112)
                .addComponent(jLabel6)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(lbTelefone)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jpClienteLayout.setVerticalGroup(
            jpClienteLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jpClienteLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jpClienteLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jpClienteLayout.createSequentialGroup()
                        .addGroup(jpClienteLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel1)
                            .addComponent(ftfCpf, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(25, 25, 25))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jpClienteLayout.createSequentialGroup()
                        .addComponent(btBuscar, javax.swing.GroupLayout.PREFERRED_SIZE, 34, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)))
                .addGroup(jpClienteLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel2)
                    .addComponent(lbNome)
                    .addComponent(jLabel4)
                    .addComponent(lbSexo)
                    .addComponent(jLabel6)
                    .addComponent(lbTelefone))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jPanel2.setBorder(javax.swing.BorderFactory.createTitledBorder(javax.swing.BorderFactory.createEtchedBorder(), "Agendamento"));

        jLabel8.setText("Data:");

        jLabel9.setText("Horário:");

        jtAgendamento.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "Código", "Serviço", "Valor"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.String.class, java.lang.String.class, java.lang.String.class
            };
            boolean[] canEdit = new boolean [] {
                false, false, false
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jtAgendamento.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        jtAgendamento.getTableHeader().setReorderingAllowed(false);
        jScrollPane1.setViewportView(jtAgendamento);
        if (jtAgendamento.getColumnModel().getColumnCount() > 0) {
            jtAgendamento.getColumnModel().getColumn(0).setResizable(false);
            jtAgendamento.getColumnModel().getColumn(0).setPreferredWidth(50);
            jtAgendamento.getColumnModel().getColumn(1).setResizable(false);
            jtAgendamento.getColumnModel().getColumn(1).setPreferredWidth(300);
            jtAgendamento.getColumnModel().getColumn(2).setResizable(false);
            jtAgendamento.getColumnModel().getColumn(2).setPreferredWidth(30);
        }

        jLabel10.setText("Serviço:");

        btAdicionar.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagens/list-add-7.png"))); // NOI18N
        btAdicionar.setText("adicionar");
        btAdicionar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btAdicionarActionPerformed(evt);
            }
        });

        cbHorario.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cbHorarioActionPerformed(evt);
            }
        });

        btRemover.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagens/delete_table_row.png"))); // NOI18N
        btRemover.setText("Remover");
        btRemover.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btRemoverActionPerformed(evt);
            }
        });

        btExibir.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagens/arrow-right-3.png"))); // NOI18N
        btExibir.setText("Exibir");
        btExibir.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btExibirActionPerformed(evt);
            }
        });

        jLabel3.setText("Horários Disponíveis:");

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 625, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addComponent(btRemover))
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jPanel2Layout.createSequentialGroup()
                                .addComponent(jLabel10)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(cbServico, javax.swing.GroupLayout.PREFERRED_SIZE, 170, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addGroup(jPanel2Layout.createSequentialGroup()
                                .addGap(6, 6, 6)
                                .addComponent(jLabel8)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(dcData, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jPanel2Layout.createSequentialGroup()
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jLabel3)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(btExibir)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addComponent(jLabel9)
                                .addGap(18, 18, 18)
                                .addComponent(cbHorario, javax.swing.GroupLayout.PREFERRED_SIZE, 137, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addGroup(jPanel2Layout.createSequentialGroup()
                                .addGap(30, 30, 30)
                                .addComponent(btAdicionar)
                                .addGap(0, 0, Short.MAX_VALUE)))))
                .addContainerGap(60, Short.MAX_VALUE))
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel2Layout.createSequentialGroup()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(dcData, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel8)
                    .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(jLabel9)
                        .addComponent(btExibir)
                        .addComponent(jLabel3)
                        .addComponent(cbHorario, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addGap(18, 27, Short.MAX_VALUE)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jLabel10)
                    .addComponent(cbServico, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(btAdicionar, javax.swing.GroupLayout.PREFERRED_SIZE, 36, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 133, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(btRemover, javax.swing.GroupLayout.PREFERRED_SIZE, 34, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(25, 25, 25))
        );

        btAgendar.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagens/address-book-new-3.png"))); // NOI18N
        btAgendar.setText("Agendar");
        btAgendar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btAgendarActionPerformed(evt);
            }
        });

        jLabel11.setFont(new java.awt.Font("Ubuntu", 1, 15)); // NOI18N
        jLabel11.setText("Valor Parcial:");

        lbValorParcial.setFont(new java.awt.Font("Ubuntu", 1, 15)); // NOI18N
        lbValorParcial.setForeground(new java.awt.Color(20, 149, 13));
        lbValorParcial.setText("R$0,0");

        btCancelar.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagens/dialog-cancel-3.png"))); // NOI18N
        btCancelar.setText("Cancelar");
        btCancelar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btCancelarActionPerformed(evt);
            }
        });

        btLimparCampos.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagens/edit-clear-3.png"))); // NOI18N
        btLimparCampos.setText("Limpar");
        btLimparCampos.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btLimparCamposActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jpCliente, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jPanel2, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                        .addContainerGap())
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addGap(0, 0, Short.MAX_VALUE)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                                .addComponent(jLabel11)
                                .addGap(18, 18, 18)
                                .addComponent(lbValorParcial)
                                .addGap(97, 97, 97))
                            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                                .addComponent(btLimparCampos)
                                .addGap(58, 58, 58)
                                .addComponent(btCancelar)
                                .addGap(47, 47, 47)
                                .addComponent(btAgendar)
                                .addContainerGap())))))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel11)
                    .addComponent(lbValorParcial))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jpCliente, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(12, 12, 12)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(btLimparCampos, javax.swing.GroupLayout.PREFERRED_SIZE, 0, Short.MAX_VALUE)
                    .addComponent(btAgendar, javax.swing.GroupLayout.PREFERRED_SIZE, 0, Short.MAX_VALUE)
                    .addComponent(btCancelar, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );

        pack();
        setLocationRelativeTo(null);
    }// </editor-fold>//GEN-END:initComponents

    private void btBuscarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btBuscarActionPerformed
        if(ftfCpf.getText().equals("   .   .   -  ")){
            JOptionPane.showMessageDialog(null, "O campo 'CPF' não foi preenchido, preencha e tente novamente","CPF não informado",JOptionPane.WARNING_MESSAGE);
            return;
        }
        
        try {
            ClienteDao cdao = new ClienteDao();
            agendamento.setCliente(cdao.procurarClienteCpf(this.ftfCpf.getText()));
            this.setClienteGUI(agendamento.getCliente());
        } catch (Exception ex) {
            JOptionPane.showMessageDialog(null, ex);
            return;
        }
        
        lbNome.setText(agendamento.getCliente().getNome());
        lbSexo.setText(agendamento.getCliente().getSexo());
        lbTelefone.setText(agendamento.getCliente().getTelefone());
        ftfCpf.setText(agendamento.getCliente().getCpf());
        setServicoGUI();
        

    }//GEN-LAST:event_btBuscarActionPerformed

    private void btCancelarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btCancelarActionPerformed
        this.dispose();
    }//GEN-LAST:event_btCancelarActionPerformed

    private void cbHorarioActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cbHorarioActionPerformed

    }//GEN-LAST:event_cbHorarioActionPerformed

    private void btExibirActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btExibirActionPerformed
        if(dcData.getDate() == null){
            JOptionPane.showMessageDialog(null, "Nenhuma data selecionado","selecione a data",JOptionPane.WARNING_MESSAGE);
            return;
        }
        
        cbHorario.removeAllItems();
        try {
            ArrayList<String> horarios = (new AgendamentoDao()).buscarHorariosDisponiveis(dcData.getDate());
            for(String s : horarios)
                cbHorario.addItem(s);
        } catch (Exception e) {
            JOptionPane.showMessageDialog(null, e);
        }
        
        cbHorario.setEnabled(true);
    }//GEN-LAST:event_btExibirActionPerformed

    private void btAdicionarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btAdicionarActionPerformed
        try {
            if(cbServico.getSelectedIndex() == -1){
                JOptionPane.showMessageDialog(null, "Nenhum serviço selecionado","selecione o serviço",JOptionPane.WARNING_MESSAGE);
                return;
            }
            
            ServicoDao sdao = new ServicoDao();
            Servico servico = sdao.procurarServico((String) cbServico.getSelectedItem());
            
            if(agendamento.isContemServico(servico.getId())){
                JOptionPane.showMessageDialog(null, "Serviço já foi adicionado a lista de serviços","Serviço já adicionado",JOptionPane.WARNING_MESSAGE);
                return;
            }
            
            agendamento.getServisos().add(servico);
            
            modelo.addRow(new Object[]{
                servico.getCodigoServico(),
                servico.getNome(),
                "R$"+servico.getValor()
            });
            
            agendamento.calcularValorTotal();
            lbValorParcial.setText(("R$"+agendamento.getValorTotal()).replace('.', ','));
        } catch (Exception ex) {
            JOptionPane.showMessageDialog(null, ex);
        }
    }//GEN-LAST:event_btAdicionarActionPerformed

    private void btRemoverActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btRemoverActionPerformed
        int linhaSelecionada = jtAgendamento.getSelectedRow();
        if(linhaSelecionada == -1){
            JOptionPane.showMessageDialog(null, "Nenhum serviço selecionado na tabela","selecione o serviço",JOptionPane.WARNING_MESSAGE);
            return;
        }
        
        agendamento.removerServico((String) modelo.getValueAt(linhaSelecionada, 0));
        agendamento.calcularValorTotal();
        lbValorParcial.setText(("R$"+agendamento.getValorTotal()).replace('.', ','));
        
        modelo.removeRow(jtAgendamento.getSelectedRow());
    }//GEN-LAST:event_btRemoverActionPerformed

    private void btAgendarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btAgendarActionPerformed
        if(lbNome.getText().equals("---")){
            JOptionPane.showMessageDialog(null, "Nenhum Cliente foi selecionado","selecione o cliente",JOptionPane.WARNING_MESSAGE);
            return;
        }
        
        if(dcData.getDate() == null){
            JOptionPane.showMessageDialog(null, "Nenhuma Data foi selecionada","selecione a data",JOptionPane.WARNING_MESSAGE);
            return;
        }
        
        if(cbHorario.getSelectedIndex() == -1){
            JOptionPane.showMessageDialog(null, "Nenhum Horário foi selecionado","selecione o cliente",JOptionPane.WARNING_MESSAGE);
            return;
        }
        
        if(modelo.getRowCount() == 0){
            JOptionPane.showMessageDialog(null, "Nenhum Serviço foi selecionado\nadicione ao menos 1 para o agendamento","selecione algum serviço",JOptionPane.WARNING_MESSAGE);
            return;
        }
        
        agendamento.setData(dcData.getDate());
        
        SimpleDateFormat sdf = new SimpleDateFormat("HH:mm:ss");
        try {
            agendamento.setHorario((sdf.parse((String) cbHorario.getSelectedItem())));
        } catch (ParseException ex) {
            JOptionPane.showMessageDialog(null, ex);
            return;
        }
        
        try {
            (new AgendamentoDao()).agendar(agendamento);
        } catch (Exception e){
            JOptionPane.showMessageDialog(null, e);
            return;
        }
        
        JOptionPane.showMessageDialog(null, "Agendamento realizado com sucesso!","Agendamento realizado",JOptionPane.INFORMATION_MESSAGE);
        limparGUI();
        
        
    }//GEN-LAST:event_btAgendarActionPerformed

    private void btLimparCamposActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btLimparCamposActionPerformed
        limparGUI();
    }//GEN-LAST:event_btLimparCamposActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(FormAgendamento.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(FormAgendamento.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(FormAgendamento.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(FormAgendamento.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new FormAgendamento().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btAdicionar;
    private javax.swing.JButton btAgendar;
    private javax.swing.JButton btBuscar;
    private javax.swing.JButton btCancelar;
    private javax.swing.JButton btExibir;
    private javax.swing.JButton btLimparCampos;
    private javax.swing.JButton btRemover;
    private javax.swing.JComboBox<String> cbHorario;
    private javax.swing.JComboBox<String> cbServico;
    private com.toedter.calendar.JDateChooser dcData;
    private javax.swing.JFormattedTextField ftfCpf;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JPanel jpCliente;
    private javax.swing.JTable jtAgendamento;
    private javax.swing.JLabel lbNome;
    private javax.swing.JLabel lbSexo;
    private javax.swing.JLabel lbTelefone;
    private javax.swing.JLabel lbValorParcial;
    // End of variables declaration//GEN-END:variables

    private void setClienteGUI(Cliente cliente) {
        this.lbNome.setText(cliente.getNome());
        this.lbSexo.setText(cliente.getSexo());
        this.lbTelefone.setText(cliente.getTelefone());
    }

    private void setServicoGUI() {
        List<Servico> a = new ArrayList<>();
        try {
            ServicoDao sdao = new ServicoDao();
            a = sdao.todosServicos();
        } catch (Exception ex) {
            Logger.getLogger(FormAgendamento.class.getName()).log(Level.SEVERE, null, ex);
        }
        for (Servico b : a) {
            cbServico.addItem(b.getNome());
        }
        cbServico.setSelectedIndex(-1);
    }
    
    private void limparGUI(){
        ftfCpf.setValue("");
        lbNome.setText("---");
        lbSexo.setText("---");
        lbTelefone.setText("---");
        lbValorParcial.setText("R$0,0");
        
        cbHorario.setSelectedIndex(-1);
        cbHorario.setEnabled(false);
        
        cbServico.setSelectedIndex(-1);
        
        dcData.setDate(null);
        
        limparTabela();
        
        agendamento = new Agendamento();
        agendamento.setCliente(new Cliente());
    }
    
    private void limparTabela(){
        for(int i = modelo.getRowCount()-1; i>=0;i--)
            modelo.removeRow(i);
    }
}
